// CNAM RSX104 - ED3 exercice 2
// subdivision recursive du mouvement brownien
// Pierre Cubaud, cubaud@cnam.fr, mars 2009

float D=30.0;
int N=8;
float H=0.9;

void setup(){
   size(600,600);
   //strokeWeight(4);
   smooth();
}

void draw() {
posit deb, fin, p,q;
float s,r,xm,ym;int i;
 
 randomSeed(1);
 H = map(mouseY,0,height,0.999,0);
 N = int(map(mouseX,0,width,1,12));
 fin=Nouveau(10, 300,null);
 deb=Nouveau(590, 300,fin);
 s=sqrt(D*D);
 
 for(i=1;i<=N;i++){
   p=deb;
   while (p!=fin){
    xm=Normal((p.x+p.suiv.x)/2.0,s); // 0 ou s
    ym=Normal((p.y+p.suiv.y)/2.0,s);   
    q=Nouveau(xm,ym,p.suiv);
    p.suiv=q;
    p=q.suiv;
   }
  s /= pow(2.0,H);
 }
 background(255);
 p=deb;
 while (p.suiv!=null) {
  line(p.x,p.y,p.suiv.x,p.suiv.y);
  p=p.suiv;
 }

}

class posit {
  float x;
  float y;
  posit suiv;
}

posit Nouveau(float px, float py, posit ps){
  posit n=new posit();
  n.x = px; n.y = py; n.suiv = ps; 
  return n;
}

float Normal(float m, float s) {
  //return random(m-1.732*s,m+1.732*s);
  float theta = random(0,2*PI);
  float r = sqrt(-2*log(random(0,1)));
  return m+s*r*cos(theta);
}
